/* koeunpac.c
   KOEwavɕϊ
   WXgwav炷ݒɏ

   01/03/23 initial
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <io.h>
#include <stdarg.h>
#include <direct.h>

#define PROGNAME	"koeunpac.exe"
#define REGFILENAME "koe_restore.reg"
#define DEFAULT_RATE 22050

/* oCgobt@ s[]  n Ԗڂ nibble 𓾂
   obt@e $AB $CD $EF ... ƂƁAn=0,1,2,3...̕Ԓl
   $0B $0A $0D $0C ... ƂȂ܂B */
#define nibble(s,n) (((s)[(n)>>1]>>(((n)&1)<<2))&15)

#pragma pack(push, 1)

struct wave_header {
	char riff[4];
	DWORD riffsize;
	char wave[4];
	char fmt[4];
	DWORD fmtsize;
	WAVEFORMAT wf;
	WORD wBitsPerSample;
	char data[4];
	DWORD datasize;
};

struct koe_header {
	char id[16];	/* "KOEPAC" */
	long nvoice;	/* Ăwave̐ */
	long unknown1;
	long rate;		/* TvO[g */
	long unknown2;
};

struct koe_table {
	unsigned short id;
	unsigned short nsymbol;
	unsigned long pos;		/* t@ĆAf[^Jnʒu */
};

#pragma pack(pop)

/* U8bitf[^16bitPCMւ̕ϊe[u */
static short LinearTable[256];
/* 4/8bit DifferencialPCM nibble? -> oCgf[^ */
static unsigned char table2[256];

void init_tables(void)
{
	short i, n;
	
	for (i = -0x80; i < 0x80; i++)
		LinearTable[i+0x80] = 2*i*abs(i);
	
	for (i = 0; i < 256; i++) {
		n = (i >> 1);
		if (i & 1) n ^= 0xff;		// ŉʃrbgnibble̕L
		table2[i] = 256 - n;
	}
}

void fputw(short w, FILE *fp)
{
	fputc(w & 0xff, fp);
	fputc((w >> 8) & 0xff, fp);
}

int msgboxf(UINT style, const char* fmt, va_list arglist)
{
	char buf[1024];
	vsprintf(buf, fmt, arglist);
	return MessageBox(NULL, buf, PROGNAME, style);
}

void showerror(const char* fmt, ...)
{
	va_list argptr;

	va_start(argptr, fmt);
	msgboxf(MB_OK | MB_ICONSTOP, fmt, argptr);
	va_end(argptr);
}

int yes_no(const char* fmt, ...)
{
	int r;
	va_list argptr;

	va_start(argptr, fmt);
	r = msgboxf(MB_YESNO, fmt, argptr);
	va_end(argptr);
	return r;
}

/* t@C̑݌ */
int exist(const char *fname)
{
	if (access(fname, 0) == -1 && errno == ENOENT) {
		errno = 0;
		return 0;
	}
	return 1;
}

void write_wave_header(FILE *fp, long size, long rate)
{
	struct wave_header wavhdr = {
		{'R', 'I', 'F', 'F'},
		0,
		{'W', 'A', 'V', 'E'},
		{'f', 'm', 't', ' '},
		16,
		{ WAVE_FORMAT_PCM, 1, 0, 0, 2 },
		16,
		{'d', 'a', 't', 'a'},
		0
	};
	wavhdr.riffsize = size + sizeof(struct wave_header) - 8;
	wavhdr.wf.nSamplesPerSec = rate;
	wavhdr.wf.nAvgBytesPerSec = rate * 2;
	wavhdr.datasize = size;
	fwrite(&wavhdr, sizeof wavhdr, 1, fp);
}

int decode(const char *fname, const struct koe_header *koehdr,
		   const struct koe_table *table, FILE *koe)
{
	unsigned short *symlist;
	FILE *wav;
	int i, j;
	long datasize;

	/* V{Xgǂݍ */
	symlist = malloc(table->nsymbol * 2);
	fseek(koe, table->pos, SEEK_SET);
	fread(symlist, 2, table->nsymbol, koe);

	/* wavet@C쐬 */
	wav = fopen(fname, "wb");
	if (wav == NULL) {
		showerror("%s쐬ł܂B", fname);
		return 1;
	}
	fseek(wav, sizeof(struct wave_header), SEEK_SET);	/* wb_̕ */
	
	/* ł[ǂ */
	for (i = 0; i < table->nsymbol; i++) {
		if (symlist[i] == 0) {			/* ^H */
			for (j = 0; j < 0x400; j++)
				fputw(0, wav);
		}
		else if (symlist[i] == 0x400) {
			for (j = 0; j < 0x400; j++)
				fputw(LinearTable[fgetc(koe)], wav);
		}
		else {
			BYTE data = 0;
			unsigned char *src = malloc(symlist[i]);
			fread(src, symlist[i], 1, koe);
			
			for (j = 0; j < symlist[i] * 2; ) {
				BYTE s = nibble(src, j);		/* ܂1nibbleE  */
				j++;
				if (s == 15) {					/* nibble15̎ */
					s = nibble(src, j);			/* nibble2E  */
					j++;
					s |= (nibble(src, j) << 4);
					j++;
				}
				data += table2[s];			/* 8bitTvOf[^ɉZ */
				fputw(LinearTable[data], wav);
			}
			free(src);
		}
	}
	free(symlist);

	/* wavewb_ */
	datasize = ftell(wav) - sizeof(struct wave_header);
	fseek(wav, 0, SEEK_SET);
	write_wave_header(wav, datasize, koehdr->rate ? koehdr->rate : DEFAULT_RATE);

	fclose(wav);
	return 0;
}

int unpac_koe(const char *dir, const char* name)
{
	char id[4];
	char koename[MAX_PATH], wavname[MAX_PATH];
	FILE *koe;
	struct koe_header hdr;
	struct koe_table *table;
	int i;

	sprintf(koename, "%s\\%s", dir, name);
	koe = fopen(koename, "rb");
	if (koe == NULL) {
		showerror("%sI[vł܂B", koename);
		return 1;
	}

	fread(&hdr, sizeof hdr, 1, koe);
	if (strcmp(hdr.id, "KOEPAC") != 0) {
		showerror("%sKOE`ł͂Ȃ悤łB", koename);
		return 1;
	}
	
	table = malloc(sizeof(struct koe_table) * hdr.nvoice);
	fread(table, sizeof(struct koe_table), hdr.nvoice, koe);

	/* Zxxx.KOE  xxx ̕𔲂o */
	strncpy(id, &name[1], 3);
	id[3] = '\0';
	
	if (_mkdir(id) == -1) {
		showerror("tH_ %s 쐬ł܂: %s", id, strerror(errno));
		return 1;
	}
	
	for (i = 0; i < hdr.nvoice; i++) {
		sprintf(wavname, "%s\\Z%s%05d.WAV", id, id, table[i].id);
		printf("%s -> %s\n", name, wavname);
		if (decode(wavname, &hdr, &table[i], koe))
			return 1;
	}
	
	free(table);
	fclose(koe);
	return 0;
}

void makeregfile(const char *key, const char *koefolder)
{
	FILE *fp;
	const char *p;
	
	if (exist(REGFILENAME)) {
		if (yes_no(REGFILENAME "ɂ܂B㏑܂H") == IDNO)
			return;
	}
	
	fp = fopen(REGFILENAME, "wt");
	if (fp == NULL) {
		showerror(REGFILENAME "̍쐬Ɏs܂B");
		return;
	}
	fprintf(fp, "REGEDIT4\n");
	fprintf(fp, "[HKEY_CURRENT_USER\\%s]\n", key);
	fprintf(fp, "\"KOE_FOLDER\"=\"");
	for (p = koefolder; *p; p++) {
		if (*p == '\\')
			fputc('\\', fp);
		fputc(*p, fp);
	}
	fprintf(fp, "\"\n");
	fclose(fp);
}

/* GAMEEXE.INI烌WXgL[𒲂ׁÃWXgKOEtH_𓾂 */
/* KOEtH_ or NULL(s) Ԃ */
char *getkoedir(void)
{
	FILE *fp;
	HKEY hkey;
	char buf[1024], str[256], key[256], *folder;
	DWORD size = 256;
	LONG r;

	fp = fopen("GAMEEXE.INI", "rt");
	if (fp == NULL) {
		showerror("GAMEEXE.INItH_ŎsĂB");
		return NULL;
	}
	
	while (fgets(buf, sizeof buf, fp) != NULL) {
		if (sscanf(buf, "#REGNAME = \"%[^\"]\"", str) == 0)
			continue;
		
		sprintf(key, "Software\\%s", str);
		r = RegOpenKeyEx(HKEY_CURRENT_USER, key, 0,
						 KEY_QUERY_VALUE | KEY_SET_VALUE, &hkey);
		if (r != ERROR_SUCCESS) {
			showerror("WXg %s J܂B", key);
			return NULL;
		}
		
		folder = malloc(size);
		r = RegQueryValueEx(hkey, "KOE_FOLDER", 0, NULL, folder, &size);
		if (r == ERROR_SUCCESS) {
			RegSetValueEx(hkey, "KOE_FOLDER", 0, REG_SZ, "koewav", 7);
			makeregfile(key, folder);
		}
		else {
			showerror("%s\\KOE_FOLDER ǂ߂܂B", key);
			folder = NULL;
		}
		RegCloseKey(hkey);
		return folder;
	}
	showerror("GAMEEXE.INIɍ#REGNAME܂B");
	return NULL;
}

int main(int argc, char *argv[])
{
	char pat[MAX_PATH];
	WIN32_FIND_DATA ffd;
	HANDLE hf;
	int err = 0;
	char *koedir;

	koedir = getkoedir();
	if (koedir == NULL)
		return 1;
	
	if (_mkdir("koewav") == -1) {
		showerror("tH_ koewav 쐬ł܂: %s", strerror(errno));
		return 1;
	}
	chdir("koewav");

	sprintf(pat, "%s\\Z???.KOE", koedir);
	hf = FindFirstFile(pat, &ffd);
	if (hf == INVALID_HANDLE_VALUE) {
		showerror("tH_ %s KOEt@C܂B", koedir);
		return 1;
	}
	else {
		init_tables();
		do {
			if (unpac_koe(koedir, ffd.cFileName)) {
				err = 1;
				break;
			}
		} while (FindNextFile(hf, &ffd));
		FindClose(hf);
	}
	return err;
}
